; ================================================================================
; 								RallyeLect
; ================================================================================
;
; 	Par Cyrille Largillier en s'insiprant des scripts de fat115
; 	Sur une ide de Sbastien Clerval
; 	License : Ceccil
; 	Ce script permet de gnrer des fiches de rallye-lecture
; 	Compiler: AutoHotkey (http://www.autohotkey.com/).
;	Email : cyrille.largillier@free.Fr
;	Website : http://melospawn.free.fr
; ================================================================================

; On force le rpertoire des includes  tre celui du script
#Include %A_ScriptDir%
; On dsactive l'icne de la barre des tches
#NoTrayIcon
; On inclut pour le traitement des fichiers xml
#Include xpath.ahk
; Pour la suite, on dfinit de manire explicite le rpertoire de travail
SetWorkingDir %A_ScriptDir%
; On dfinit le format des Float
SetFormat, FloatFast, 0.2

; Traitement des PDF, chargement de la librairie HARU
#Include HPDF.ahk
hpdfDllFile := A_ScriptDir "\libhpdf.dll"
hDll := HPDF_LoadDLL(hpdfDllFile)

; On dfinit les sous dossiers pour le traitement des fichiers temporaires et des images
PDFDir := A_ScriptDir . "\PDF"
ProjetDir := A_ScriptDir . "\Projet"
PDFLecteur := A_ScriptDir . "\SumatraPDF\SumatraPDF.exe"

LogMsg := ""
NomFichierQuestion := ""
NomFichierCorrection := ""

; ================================================================================
;					 Dfinition de la GUI principale
; ================================================================================
MainGuiDef:
{
	; Dfinitions des Boutons & Onglets 

	Gui, Add, Button, x15 y15 w120 h30 vCreatePDF gCreatePDF, Crer la fiche-question
	Gui, Add, Button, x15 y65 w120 h30 Disabled vReadPDF gReadPDF, Lire la fiche-question
	Gui, Add, Button, x15 y115 w120 h30 Disabled vCreatePDFCorrection gCreatePDFCorrection, Crer la fiche-correction
	Gui, Add, Button, x15 y165 w120 h30 Disabled vReadPDFCorrection gReadPDFCorrection, Lire la fiche-correction
	Gui, Add, Button, x15 y215 w120 h30 vAide gAide, Aide
	Gui, Add, Button, x15 y265 w120 h30 vGuiClose gGuiClose, Quitter

	Gui, Add, Text, x173 y55 w152 h16 , Nombres alatoires de
	Gui, Add, Edit, x302 y52 w50 h22 vAleatoireDebut, 
	Gui, Add, Text, x370 y55 w20 h16 , 
	Gui, Add, Edit, x392 y52 w50 h22 vAleatoireFin, 
	
	Gui, Add, Text, x173 y120 w152 h16 , Consigne
	Gui, Add, Edit, x173 y138 w300 h22 vConsigne,
	
	Gui, Add, Text, x173 y180 w152 h16 , Comptence
	Gui, Add, Edit, x173 y198 w300 h22 vCompetence,
	
	
	Gui, Add, Text, x173 y270 w152 h16 , Nom d'enregistrement du fichier
	Gui, Add, Edit, x332 y268 w150 h22 vNomFichier, 


		
	
	Gui, Add, StatusBar, gLogWindow

	Gui, Show, Center h340 w500, Quadrition
Return
}


; ================================================================================
;						Gestion des boutons
; ================================================================================

;================================================================================================
;================================================================================================
; Gnrer le PDF
;================================================================================================
;================================================================================================
CreatePDF:
{
Gui, Submit, NoHide

		
LogStatus("Dbut de la cration de la fiche-question")

;================================================================================================
; Vrification que les champs ont bien t remplis par l'utilisateur
;================================================================================================
If (NomFichier = "")
		{
		MsgBox, 16, Oubli du nom de fichier, Il faut un nom au fichier.
		Return
		}

If (AleatoireDebut = "")
		{
		MsgBox, 16, Borne infrieure, La borne infrieure est vide.
		Return
		}

If (AleatoireFin = "")
		{
		MsgBox, 16, Borne suprieure, La borne suprieure est vide.
		Return
		}		
		
If AleatoireDebut is not Integer
		{
		MsgBox, 16, Borne infrieure, La borne infrieure n'est pas un entier naturel.
		Return
		}
		
If AleatoireFin is not Integer
		{
		MsgBox, 16, Borne suprieure, La borne suprieure n'est pas un entier naturel.
		Return
		}				

;Cration d'un nouveau document PDF en mmoire
hDoc := HPDF_New("error","000")

;Cration de la police par dfaut
font := HPDF_GetFont(hDoc, "Helvetica", "WinAnsiEncoding")

;Crtaion d'une page, A4, Paysage
page := HPDF_AddPage(hDoc)
HPDF_Page_SetSize(page, "A4", "LANDSCAPE")

;Mode de compression du PDF
HPDF_SetCompressionMode(hDoc, "ALL")

;================================================================================================
; Ajout des informations sur le livre et le rdacteur sur le PDF
;================================================================================================

HPDF_Page_BeginText(page)

;Ecriture du titre
; Dfinition pour le texte  crire de la police et de  sa taille puis de sa position (2me ligne)
HPDF_Page_SetFontAndSize(page, font, 24)
HPDF_Page_MoveTextPos(page, 40, 705)  

;Ajout du nom du logiciel avec lequel 
TextAEcrire = Fiche cre avec le logiciel libre Quadrition - http://melospawn.free.fr

HPDF_Page_SetFontAndSize(page, font, 6)
angle1 := 90                   ; A rotation of 90 degrees.
rad1 := angle1 / 180 * 3.141592 ; Calcurate the radian value.
HPDF_Page_SetTextMatrix(page, cos(rad1), sin(rad1), -sin(rad1), cos(rad1), 20, 80)
HPDF_Page_ShowText(page, TextAEcrire)
HPDF_Page_EndText(page)

;================================================================================================
; Ajout des rectangles comportant les nombres
;================================================================================================

; En haut  gauche
HPDF_Page_SetRGBFill(page, 0.7, 0.7, 0.7)
HPDF_Page_Rectangle(page, 40, 360, 60, 30)
HPDF_Page_Rectangle(page, 300, 360, 60, 30)

HPDF_Page_Fill(page)

HPDF_Page_Rectangle(page, 40, 360, 60, 30)
HPDF_Page_Rectangle(page, 300, 360, 60, 30)
HPDF_Page_Rectangle(page, 140, 360, 60, 30)
HPDF_Page_Rectangle(page, 200, 360, 60, 30)
HPDF_Page_Rectangle(page, 140, 430, 60, 30)
HPDF_Page_Rectangle(page, 200, 430, 60, 30)
HPDF_Page_Rectangle(page, 300, 430, 60, 30)
HPDF_Page_Rectangle(page, 140, 460, 60, 30)
HPDF_Page_Rectangle(page, 200, 460, 60, 30)
HPDF_Page_Rectangle(page, 300, 460, 60, 30)

HPDF_Page_Stroke(page)	

; En haut  droite
HPDF_Page_SetRGBFill(page, 0.7, 0.7, 0.7)
HPDF_Page_Rectangle(page, 460, 360, 60, 30)
HPDF_Page_Rectangle(page, 720, 360, 60, 30)
HPDF_Page_Fill(page)

HPDF_Page_Rectangle(page, 460, 360, 60, 30)
HPDF_Page_Rectangle(page, 720, 360, 60, 30)
HPDF_Page_Rectangle(page, 560, 360, 60, 30)
HPDF_Page_Rectangle(page, 620, 360, 60, 30)
HPDF_Page_Rectangle(page, 560, 430, 60, 30)
HPDF_Page_Rectangle(page, 620, 430, 60, 30)
HPDF_Page_Rectangle(page, 720, 430, 60, 30)
HPDF_Page_Rectangle(page, 560, 460, 60, 30)
HPDF_Page_Rectangle(page, 620, 460, 60, 30)
HPDF_Page_Rectangle(page, 720, 460, 60, 30)

HPDF_Page_Stroke(page)	

; En bas  gauche
HPDF_Page_SetRGBFill(page, 0.7, 0.7, 0.7)
HPDF_Page_Rectangle(page, 40, 60, 60, 30)
HPDF_Page_Rectangle(page, 300, 60, 60, 30)
HPDF_Page_Fill(page)

HPDF_Page_Rectangle(page, 40, 60, 60, 30)
HPDF_Page_Rectangle(page, 300, 60, 60, 30)
HPDF_Page_Rectangle(page, 140, 60, 60, 30)
HPDF_Page_Rectangle(page, 200, 60, 60, 30)
HPDF_Page_Rectangle(page, 140, 130, 60, 30)
HPDF_Page_Rectangle(page, 200, 130, 60, 30)
HPDF_Page_Rectangle(page, 300, 130, 60, 30)
HPDF_Page_Rectangle(page, 140, 160, 60, 30)
HPDF_Page_Rectangle(page, 200, 160, 60, 30)
HPDF_Page_Rectangle(page, 300, 160, 60, 30)

HPDF_Page_Stroke(page)	
			
; En bas  droite
HPDF_Page_SetRGBFill(page, 0.7, 0.7, 0.7)
HPDF_Page_Rectangle(page, 460, 60, 60, 30)
HPDF_Page_Rectangle(page, 720, 60, 60, 30)
HPDF_Page_Fill(page)

HPDF_Page_Rectangle(page, 460, 60, 60, 30)
HPDF_Page_Rectangle(page, 720, 60, 60, 30)
HPDF_Page_Rectangle(page, 560, 60, 60, 30)
HPDF_Page_Rectangle(page, 620, 60, 60, 30)
HPDF_Page_Rectangle(page, 560, 130, 60, 30)
HPDF_Page_Rectangle(page, 620, 130, 60, 30)
HPDF_Page_Rectangle(page, 720, 130, 60, 30)
HPDF_Page_Rectangle(page, 560, 160, 60, 30)
HPDF_Page_Rectangle(page, 620, 160, 60, 30)
HPDF_Page_Rectangle(page, 720, 160, 60, 30)

HPDF_Page_Stroke(page)				
				
HPDF_Page_MoveTo(page, 420, 0)
HPDF_Page_LineTo(page, 420, 600)
HPDF_Page_MoveTo(page, 0, 300)
HPDF_Page_LineTo(page, 840, 300)
HPDF_Page_Stroke(page)
			
;================================================================================================
; Ajout des fleches
;================================================================================================
; fleches du carr A
HPDF_Page_MoveTo(page, 170, 420)
HPDF_Page_LineTo(page, 170, 400)
HPDF_Page_MoveTo(page, 180, 410)
HPDF_Page_LineTo(page, 170, 400)
HPDF_Page_LineTo(page, 160, 410)

HPDF_Page_MoveTo(page, 230, 420)
HPDF_Page_LineTo(page, 230, 400)
HPDF_Page_MoveTo(page, 240, 410)
HPDF_Page_LineTo(page, 230, 400)
HPDF_Page_LineTo(page, 220, 410)

HPDF_Page_MoveTo(page, 330, 420)
HPDF_Page_LineTo(page, 330, 400)
HPDF_Page_MoveTo(page, 340, 410)
HPDF_Page_LineTo(page, 330, 400)
HPDF_Page_LineTo(page, 320, 410)

HPDF_Page_MoveTo(page, 270, 475)
HPDF_Page_LineTo(page, 290, 475)
HPDF_Page_MoveTo(page, 280, 485)
HPDF_Page_LineTo(page, 290, 475)
HPDF_Page_LineTo(page, 280, 465)

HPDF_Page_MoveTo(page, 270, 445)
HPDF_Page_LineTo(page, 290, 445)
HPDF_Page_MoveTo(page, 280, 455)
HPDF_Page_LineTo(page, 290, 445)
HPDF_Page_LineTo(page, 280, 435)

HPDF_Page_MoveTo(page, 130, 375)
HPDF_Page_LineTo(page, 110, 375)
HPDF_Page_MoveTo(page, 120, 385)
HPDF_Page_LineTo(page, 110, 375)
HPDF_Page_LineTo(page, 120, 365)

; fleches du carr B
HPDF_Page_MoveTo(page, 590, 420)
HPDF_Page_LineTo(page, 590, 400)
HPDF_Page_MoveTo(page, 600, 410)
HPDF_Page_LineTo(page, 590, 400)
HPDF_Page_LineTo(page, 580, 410)

HPDF_Page_MoveTo(page, 650, 420)
HPDF_Page_LineTo(page, 650, 400)
HPDF_Page_MoveTo(page, 660, 410)
HPDF_Page_LineTo(page, 650, 400)
HPDF_Page_LineTo(page, 640, 410)

HPDF_Page_MoveTo(page, 750, 420)
HPDF_Page_LineTo(page, 750, 400)
HPDF_Page_MoveTo(page, 760, 410)
HPDF_Page_LineTo(page, 750, 400)
HPDF_Page_LineTo(page, 740, 410)

HPDF_Page_MoveTo(page, 690, 475)
HPDF_Page_LineTo(page, 710, 475)
HPDF_Page_MoveTo(page, 700, 485)
HPDF_Page_LineTo(page, 710, 475)
HPDF_Page_LineTo(page, 700, 465)

HPDF_Page_MoveTo(page, 690, 445)
HPDF_Page_LineTo(page, 710, 445)
HPDF_Page_MoveTo(page, 700, 455)
HPDF_Page_LineTo(page, 710, 445)
HPDF_Page_LineTo(page, 700, 435)

HPDF_Page_MoveTo(page, 550, 375)
HPDF_Page_LineTo(page, 530, 375)
HPDF_Page_MoveTo(page, 540, 385)
HPDF_Page_LineTo(page, 530, 375)
HPDF_Page_LineTo(page, 540, 365)

; fleches du carr C
HPDF_Page_MoveTo(page, 170, 120)
HPDF_Page_LineTo(page, 170, 100)
HPDF_Page_MoveTo(page, 180, 110)
HPDF_Page_LineTo(page, 170, 100)
HPDF_Page_LineTo(page, 160, 110)

HPDF_Page_MoveTo(page, 230, 120)
HPDF_Page_LineTo(page, 230, 100)
HPDF_Page_MoveTo(page, 240, 110)
HPDF_Page_LineTo(page, 230, 100)
HPDF_Page_LineTo(page, 220, 110)

HPDF_Page_MoveTo(page, 330, 120)
HPDF_Page_LineTo(page, 330, 100)
HPDF_Page_MoveTo(page, 340, 110)
HPDF_Page_LineTo(page, 330, 100)
HPDF_Page_LineTo(page, 320, 110)

HPDF_Page_MoveTo(page, 270, 175)
HPDF_Page_LineTo(page, 290, 175)
HPDF_Page_MoveTo(page, 280, 185)
HPDF_Page_LineTo(page, 290, 175)
HPDF_Page_LineTo(page, 280, 165)

HPDF_Page_MoveTo(page, 270, 145)
HPDF_Page_LineTo(page, 290, 145)
HPDF_Page_MoveTo(page, 280, 155)
HPDF_Page_LineTo(page, 290, 145)
HPDF_Page_LineTo(page, 280, 135)

HPDF_Page_MoveTo(page, 130, 75)
HPDF_Page_LineTo(page, 110, 75)
HPDF_Page_MoveTo(page, 120, 85)
HPDF_Page_LineTo(page, 110, 75)
HPDF_Page_LineTo(page, 120, 65)

; fleches du carr D
HPDF_Page_MoveTo(page, 590, 120)
HPDF_Page_LineTo(page, 590, 100)
HPDF_Page_MoveTo(page, 600, 110)
HPDF_Page_LineTo(page, 590, 100)
HPDF_Page_LineTo(page, 580, 110)

HPDF_Page_MoveTo(page, 650, 120)
HPDF_Page_LineTo(page, 650, 100)
HPDF_Page_MoveTo(page, 660, 110)
HPDF_Page_LineTo(page, 650, 100)
HPDF_Page_LineTo(page, 640, 110)

HPDF_Page_MoveTo(page, 750, 120)
HPDF_Page_LineTo(page, 750, 100)
HPDF_Page_MoveTo(page, 760, 110)
HPDF_Page_LineTo(page, 750, 100)
HPDF_Page_LineTo(page, 740, 110)

HPDF_Page_MoveTo(page, 690, 175)
HPDF_Page_LineTo(page, 710, 175)
HPDF_Page_MoveTo(page, 700, 185)
HPDF_Page_LineTo(page, 710, 175)
HPDF_Page_LineTo(page, 700, 165)

HPDF_Page_MoveTo(page, 690, 145)
HPDF_Page_LineTo(page, 710, 145)
HPDF_Page_MoveTo(page, 700, 155)
HPDF_Page_LineTo(page, 710, 145)
HPDF_Page_LineTo(page, 700, 135)

HPDF_Page_MoveTo(page, 550, 75)
HPDF_Page_LineTo(page, 530, 75)
HPDF_Page_MoveTo(page, 540, 85)
HPDF_Page_LineTo(page, 530, 75)
HPDF_Page_LineTo(page, 540, 65)

HPDF_Page_Stroke(page)

;================================================================================================
; Ajout des nombres
;================================================================================================

Random, CaseA1, AleatoireDebut, AleatoireFin
Random, CaseA2, AleatoireDebut, AleatoireFin
Random, CaseA3, AleatoireDebut, AleatoireFin
Random, CaseA4, AleatoireDebut, AleatoireFin
caseA5:=caseA1+caseA2
caseA6:=caseA3+caseA4
caseA9:=caseA5+caseA6
caseA8:=caseA2+caseA4
caseA7:=caseA1+caseA3
caseA10:=caseA7+caseA8

Random, CaseB1, AleatoireDebut, AleatoireFin
Random, CaseB2, AleatoireDebut, AleatoireFin
Random, CaseB3, AleatoireDebut, AleatoireFin
Random, CaseB4, AleatoireDebut, AleatoireFin
caseB5:=caseB1+caseB2
caseB6:=caseB3+caseB4
caseB9:=caseB5+caseB6
caseB8:=caseB2+caseB4
caseB7:=caseB1+caseB3
caseB10:=caseB7+caseB8

Random, CaseC1, AleatoireDebut, AleatoireFin
Random, CaseC2, AleatoireDebut, AleatoireFin
Random, CaseC3, AleatoireDebut, AleatoireFin
Random, CaseC4, AleatoireDebut, AleatoireFin
caseC5:=caseC1+caseC2
caseC6:=caseC3+caseC4
caseC9:=caseC5+caseC6
caseC8:=caseC2+caseC4
caseC7:=caseC1+caseC3
caseC10:=caseC7+caseC8

Random, CaseD1, AleatoireDebut, AleatoireFin
Random, CaseD2, AleatoireDebut, AleatoireFin
Random, CaseD3, AleatoireDebut, AleatoireFin
Random, CaseD4, AleatoireDebut, AleatoireFin
caseD5:=caseD1+caseD2
caseD6:=caseD3+caseD4
caseD9:=caseD5+caseD6
caseD8:=caseD2+caseD4
caseD7:=caseD1+caseD3
caseD10:=caseD7+caseD8

HPDF_Page_SetRGBFill(page, 0, 0, 0)
HPDF_Page_SetFontAndSize(page, font, 12)
HPDF_Page_BeginText(page)
HPDF_Page_TextOut(page, 140+(60-HPDF_Page_TextWidth(page, caseA1))/2, 470, caseA1)
HPDF_Page_TextOut(page, 200+(60-HPDF_Page_TextWidth(page, caseA2))/2, 470, caseA2)
HPDF_Page_TextOut(page, 140+(60-HPDF_Page_TextWidth(page, caseA3))/2, 440, caseA3)
HPDF_Page_TextOut(page, 200+(60-HPDF_Page_TextWidth(page, caseA4))/2, 440, caseA4)

HPDF_Page_TextOut(page, 560+(60-HPDF_Page_TextWidth(page, caseB1))/2, 470, caseB1)
HPDF_Page_TextOut(page, 620+(60-HPDF_Page_TextWidth(page, caseB2))/2, 470, caseB2)
HPDF_Page_TextOut(page, 560+(60-HPDF_Page_TextWidth(page, caseB3))/2, 440, caseB3)
HPDF_Page_TextOut(page, 620+(60-HPDF_Page_TextWidth(page, caseB4))/2, 440, caseB4)

HPDF_Page_TextOut(page, 140+(60-HPDF_Page_TextWidth(page, caseC1))/2, 170, caseC1)
HPDF_Page_TextOut(page, 200+(60-HPDF_Page_TextWidth(page, caseC2))/2, 170, caseC2)
HPDF_Page_TextOut(page, 140+(60-HPDF_Page_TextWidth(page, caseC3))/2, 140, caseC3)
HPDF_Page_TextOut(page, 200+(60-HPDF_Page_TextWidth(page, caseC4))/2, 140, caseC4)

HPDF_Page_TextOut(page, 560+(60-HPDF_Page_TextWidth(page, caseD1))/2, 170, caseD1)
HPDF_Page_TextOut(page, 620+(60-HPDF_Page_TextWidth(page, caseD2))/2, 170, caseD2)
HPDF_Page_TextOut(page, 560+(60-HPDF_Page_TextWidth(page, caseD3))/2, 140, caseD3)
HPDF_Page_TextOut(page, 620+(60-HPDF_Page_TextWidth(page, caseD4))/2, 140, caseD4)

HPDF_Page_EndText(page)

;================================================================================================
; Ajout de la consigne
;================================================================================================
if (Consigne <> "")
	{
	 HPDF_Page_SetFontAndSize(page, font, 10)
	 HPDF_Page_BeginText(page)
	 HPDF_Page_TextOut(page, 40, 530, "Consigne : " Consigne)
	 HPDF_Page_TextOut(page, 40, 230, "Consigne : " Consigne)
	 HPDF_Page_TextOut(page, 460, 530, "Consigne : " Consigne)
	 HPDF_Page_TextOut(page, 460, 230, "Consigne : " Consigne)
	 HPDF_Page_EndText(page)
	}

if (Competence <> "")
	{
	HPDF_Page_SetFontAndSize(page, font, 8)
	 HPDF_Page_BeginText(page)
	 HPDF_Page_TextOut(page, 40, 560, "Comptence : " Competence)
	 HPDF_Page_TextOut(page, 40, 260, "Comptence : " Competence)
	 HPDF_Page_TextOut(page, 460, 560, "Comptence : " Competence)
	 HPDF_Page_TextOut(page, 460, 260, "Comptence : " Competence)
	 HPDF_Page_EndText(page)
	}
	

;================================================================================================
;Enregistre le PDF cr
;================================================================================================
NomFichierQuestion= %PDFDir%\%NomFichier%.pdf
IfExist, %NomFichierQuestion%
	{
	MsgBox, 4, , Une fiche avec ce nom existe dj. Voulez-vous le remplacer ?
	IfMsgBox, No
		{
		NomFichierQuestion= %PDFDir%\%NomFichier%01.pdf
		HPDF_SaveToFile(hDoc, NomFichierQuestion)
		}
	Else
		{
		HPDF_SaveToFile(hDoc, NomFichierQuestion)
		}
	}
Else
	{
	HPDF_SaveToFile(hDoc, NomFichierQuestion)
	}
	
; Informe l'utilisateur de la fin de cration du PDF
LogStatus("Cration de la fiche-question termine.")

; Rend cliquable le bouton "Lire le PDF" et celui "Crer correction"
GuiControl, Enable, CreatePDFCorrection
GuiControl, Enable, ReadPDF
Return
}

;================================================================================================
;================================================================================================
;Lecture du PDF de questions en ouvrant SumatraPDF
;================================================================================================
;================================================================================================
ReadPDF:
{
RunWait, "%PDFLecteur%" "%NomFichierQuestion%"
Return
}


;================================================================================================
;================================================================================================
; Gnrer le PDF de correction
;================================================================================================
;================================================================================================
CreatePDFCorrection:
{
Gui, Submit, NoHide

LogStatus("Dbut de la cration de la fiche-correction")

;================================================================================================
; Vrification que les champs ont bien t remplis par l'utilisateur
;================================================================================================
If (NomFichier = "")
		{
		MsgBox, 16, Oubli du nom de fichier, Il faut un nom au fichier.
		Return
		}

If (AleatoireDebut = "")
		{
		MsgBox, 16, Borne infrieure, La borne infrieure est vide.
		Return
		}

If (AleatoireFin = "")
		{
		MsgBox, 16, Borne suprieure, La borne suprieure est vide.
		Return
		}		
		
If AleatoireDebut is not Integer
		{
		MsgBox, 16, Borne infrieure, La borne infrieure n'est pas un entier naturel.
		Return
		}
		
If AleatoireFin is not Integer
		{
		MsgBox, 16, Borne suprieure, La borne suprieure n'est pas un entier naturel.
		Return
		}				

;Cration d'un nouveau document PDF en mmoire
hDoc := HPDF_New("error","000")

;Cration de la police par dfaut
font := HPDF_GetFont(hDoc, "Helvetica", "WinAnsiEncoding")

;Crtaion d'une page, A4, Paysage
page := HPDF_AddPage(hDoc)
HPDF_Page_SetSize(page, "A4", "LANDSCAPE")

;Mode de compression du PDF
HPDF_SetCompressionMode(hDoc, "ALL")

;================================================================================================
; Ajout des informations sur le livre et le rdacteur sur le PDF
;================================================================================================

HPDF_Page_BeginText(page)

;Ecriture du titre
; Dfinition pour le texte  crire de la police et de  sa taille puis de sa position (2me ligne)
HPDF_Page_SetFontAndSize(page, font, 24)
HPDF_Page_MoveTextPos(page, 40, 705)  


;Ajout du nom du logiciel avec lequel 
TextAEcrire = Fiche cre avec le logiciel libre Quadrition - http://melospawn.free.fr

HPDF_Page_SetFontAndSize(page, font, 6)
angle1 := 90                   ; A rotation of 90 degrees.
rad1 := angle1 / 180 * 3.141592 ; Calcurate the radian value.
HPDF_Page_SetTextMatrix(page, cos(rad1), sin(rad1), -sin(rad1), cos(rad1), 20, 80)
HPDF_Page_ShowText(page, TextAEcrire)
HPDF_Page_EndText(page)

;================================================================================================
; Ajout des rectangles comportant les nombres
;================================================================================================

; En haut  gauche
HPDF_Page_SetRGBFill(page, 0.7, 0.7, 0.7)
HPDF_Page_Rectangle(page, 40, 360, 60, 30)
HPDF_Page_Rectangle(page, 300, 360, 60, 30)

HPDF_Page_Fill(page)

HPDF_Page_Rectangle(page, 40, 360, 60, 30)
HPDF_Page_Rectangle(page, 300, 360, 60, 30)
HPDF_Page_Rectangle(page, 140, 360, 60, 30)
HPDF_Page_Rectangle(page, 200, 360, 60, 30)
HPDF_Page_Rectangle(page, 140, 430, 60, 30)
HPDF_Page_Rectangle(page, 200, 430, 60, 30)
HPDF_Page_Rectangle(page, 300, 430, 60, 30)
HPDF_Page_Rectangle(page, 140, 460, 60, 30)
HPDF_Page_Rectangle(page, 200, 460, 60, 30)
HPDF_Page_Rectangle(page, 300, 460, 60, 30)

HPDF_Page_Stroke(page)	

; En haut  droite
HPDF_Page_SetRGBFill(page, 0.7, 0.7, 0.7)
HPDF_Page_Rectangle(page, 460, 360, 60, 30)
HPDF_Page_Rectangle(page, 720, 360, 60, 30)
HPDF_Page_Fill(page)

HPDF_Page_Rectangle(page, 460, 360, 60, 30)
HPDF_Page_Rectangle(page, 720, 360, 60, 30)
HPDF_Page_Rectangle(page, 560, 360, 60, 30)
HPDF_Page_Rectangle(page, 620, 360, 60, 30)
HPDF_Page_Rectangle(page, 560, 430, 60, 30)
HPDF_Page_Rectangle(page, 620, 430, 60, 30)
HPDF_Page_Rectangle(page, 720, 430, 60, 30)
HPDF_Page_Rectangle(page, 560, 460, 60, 30)
HPDF_Page_Rectangle(page, 620, 460, 60, 30)
HPDF_Page_Rectangle(page, 720, 460, 60, 30)

HPDF_Page_Stroke(page)	

; En bas  gauche
HPDF_Page_SetRGBFill(page, 0.7, 0.7, 0.7)
HPDF_Page_Rectangle(page, 40, 60, 60, 30)
HPDF_Page_Rectangle(page, 300, 60, 60, 30)
HPDF_Page_Fill(page)

HPDF_Page_Rectangle(page, 40, 60, 60, 30)
HPDF_Page_Rectangle(page, 300, 60, 60, 30)
HPDF_Page_Rectangle(page, 140, 60, 60, 30)
HPDF_Page_Rectangle(page, 200, 60, 60, 30)
HPDF_Page_Rectangle(page, 140, 130, 60, 30)
HPDF_Page_Rectangle(page, 200, 130, 60, 30)
HPDF_Page_Rectangle(page, 300, 130, 60, 30)
HPDF_Page_Rectangle(page, 140, 160, 60, 30)
HPDF_Page_Rectangle(page, 200, 160, 60, 30)
HPDF_Page_Rectangle(page, 300, 160, 60, 30)

HPDF_Page_Stroke(page)	
			
; En bas  droite
HPDF_Page_SetRGBFill(page, 0.7, 0.7, 0.7)
HPDF_Page_Rectangle(page, 460, 60, 60, 30)
HPDF_Page_Rectangle(page, 720, 60, 60, 30)
HPDF_Page_Fill(page)

HPDF_Page_Rectangle(page, 460, 60, 60, 30)
HPDF_Page_Rectangle(page, 720, 60, 60, 30)
HPDF_Page_Rectangle(page, 560, 60, 60, 30)
HPDF_Page_Rectangle(page, 620, 60, 60, 30)
HPDF_Page_Rectangle(page, 560, 130, 60, 30)
HPDF_Page_Rectangle(page, 620, 130, 60, 30)
HPDF_Page_Rectangle(page, 720, 130, 60, 30)
HPDF_Page_Rectangle(page, 560, 160, 60, 30)
HPDF_Page_Rectangle(page, 620, 160, 60, 30)
HPDF_Page_Rectangle(page, 720, 160, 60, 30)

HPDF_Page_Stroke(page)				
				
HPDF_Page_MoveTo(page, 420, 0)
HPDF_Page_LineTo(page, 420, 600)
HPDF_Page_MoveTo(page, 0, 300)
HPDF_Page_LineTo(page, 840, 300)
HPDF_Page_Stroke(page)
			
;================================================================================================
; Ajout des fleches
;================================================================================================
; fleches du carr A
HPDF_Page_MoveTo(page, 170, 420)
HPDF_Page_LineTo(page, 170, 400)
HPDF_Page_MoveTo(page, 180, 410)
HPDF_Page_LineTo(page, 170, 400)
HPDF_Page_LineTo(page, 160, 410)

HPDF_Page_MoveTo(page, 230, 420)
HPDF_Page_LineTo(page, 230, 400)
HPDF_Page_MoveTo(page, 240, 410)
HPDF_Page_LineTo(page, 230, 400)
HPDF_Page_LineTo(page, 220, 410)

HPDF_Page_MoveTo(page, 330, 420)
HPDF_Page_LineTo(page, 330, 400)
HPDF_Page_MoveTo(page, 340, 410)
HPDF_Page_LineTo(page, 330, 400)
HPDF_Page_LineTo(page, 320, 410)

HPDF_Page_MoveTo(page, 270, 475)
HPDF_Page_LineTo(page, 290, 475)
HPDF_Page_MoveTo(page, 280, 485)
HPDF_Page_LineTo(page, 290, 475)
HPDF_Page_LineTo(page, 280, 465)

HPDF_Page_MoveTo(page, 270, 445)
HPDF_Page_LineTo(page, 290, 445)
HPDF_Page_MoveTo(page, 280, 455)
HPDF_Page_LineTo(page, 290, 445)
HPDF_Page_LineTo(page, 280, 435)

HPDF_Page_MoveTo(page, 130, 375)
HPDF_Page_LineTo(page, 110, 375)
HPDF_Page_MoveTo(page, 120, 385)
HPDF_Page_LineTo(page, 110, 375)
HPDF_Page_LineTo(page, 120, 365)

; fleches du carr B
HPDF_Page_MoveTo(page, 590, 420)
HPDF_Page_LineTo(page, 590, 400)
HPDF_Page_MoveTo(page, 600, 410)
HPDF_Page_LineTo(page, 590, 400)
HPDF_Page_LineTo(page, 580, 410)

HPDF_Page_MoveTo(page, 650, 420)
HPDF_Page_LineTo(page, 650, 400)
HPDF_Page_MoveTo(page, 660, 410)
HPDF_Page_LineTo(page, 650, 400)
HPDF_Page_LineTo(page, 640, 410)

HPDF_Page_MoveTo(page, 750, 420)
HPDF_Page_LineTo(page, 750, 400)
HPDF_Page_MoveTo(page, 760, 410)
HPDF_Page_LineTo(page, 750, 400)
HPDF_Page_LineTo(page, 740, 410)

HPDF_Page_MoveTo(page, 690, 475)
HPDF_Page_LineTo(page, 710, 475)
HPDF_Page_MoveTo(page, 700, 485)
HPDF_Page_LineTo(page, 710, 475)
HPDF_Page_LineTo(page, 700, 465)

HPDF_Page_MoveTo(page, 690, 445)
HPDF_Page_LineTo(page, 710, 445)
HPDF_Page_MoveTo(page, 700, 455)
HPDF_Page_LineTo(page, 710, 445)
HPDF_Page_LineTo(page, 700, 435)

HPDF_Page_MoveTo(page, 550, 375)
HPDF_Page_LineTo(page, 530, 375)
HPDF_Page_MoveTo(page, 540, 385)
HPDF_Page_LineTo(page, 530, 375)
HPDF_Page_LineTo(page, 540, 365)

; fleches du carr C
HPDF_Page_MoveTo(page, 170, 120)
HPDF_Page_LineTo(page, 170, 100)
HPDF_Page_MoveTo(page, 180, 110)
HPDF_Page_LineTo(page, 170, 100)
HPDF_Page_LineTo(page, 160, 110)

HPDF_Page_MoveTo(page, 230, 120)
HPDF_Page_LineTo(page, 230, 100)
HPDF_Page_MoveTo(page, 240, 110)
HPDF_Page_LineTo(page, 230, 100)
HPDF_Page_LineTo(page, 220, 110)

HPDF_Page_MoveTo(page, 330, 120)
HPDF_Page_LineTo(page, 330, 100)
HPDF_Page_MoveTo(page, 340, 110)
HPDF_Page_LineTo(page, 330, 100)
HPDF_Page_LineTo(page, 320, 110)

HPDF_Page_MoveTo(page, 270, 175)
HPDF_Page_LineTo(page, 290, 175)
HPDF_Page_MoveTo(page, 280, 185)
HPDF_Page_LineTo(page, 290, 175)
HPDF_Page_LineTo(page, 280, 165)

HPDF_Page_MoveTo(page, 270, 145)
HPDF_Page_LineTo(page, 290, 145)
HPDF_Page_MoveTo(page, 280, 155)
HPDF_Page_LineTo(page, 290, 145)
HPDF_Page_LineTo(page, 280, 135)

HPDF_Page_MoveTo(page, 130, 75)
HPDF_Page_LineTo(page, 110, 75)
HPDF_Page_MoveTo(page, 120, 85)
HPDF_Page_LineTo(page, 110, 75)
HPDF_Page_LineTo(page, 120, 65)

; fleches du carr D
HPDF_Page_MoveTo(page, 590, 120)
HPDF_Page_LineTo(page, 590, 100)
HPDF_Page_MoveTo(page, 600, 110)
HPDF_Page_LineTo(page, 590, 100)
HPDF_Page_LineTo(page, 580, 110)

HPDF_Page_MoveTo(page, 650, 120)
HPDF_Page_LineTo(page, 650, 100)
HPDF_Page_MoveTo(page, 660, 110)
HPDF_Page_LineTo(page, 650, 100)
HPDF_Page_LineTo(page, 640, 110)

HPDF_Page_MoveTo(page, 750, 120)
HPDF_Page_LineTo(page, 750, 100)
HPDF_Page_MoveTo(page, 760, 110)
HPDF_Page_LineTo(page, 750, 100)
HPDF_Page_LineTo(page, 740, 110)

HPDF_Page_MoveTo(page, 690, 175)
HPDF_Page_LineTo(page, 710, 175)
HPDF_Page_MoveTo(page, 700, 185)
HPDF_Page_LineTo(page, 710, 175)
HPDF_Page_LineTo(page, 700, 165)

HPDF_Page_MoveTo(page, 690, 145)
HPDF_Page_LineTo(page, 710, 145)
HPDF_Page_MoveTo(page, 700, 155)
HPDF_Page_LineTo(page, 710, 145)
HPDF_Page_LineTo(page, 700, 135)

HPDF_Page_MoveTo(page, 550, 75)
HPDF_Page_LineTo(page, 530, 75)
HPDF_Page_MoveTo(page, 540, 85)
HPDF_Page_LineTo(page, 530, 75)
HPDF_Page_LineTo(page, 540, 65)

HPDF_Page_Stroke(page)

;================================================================================================
; Ajout des nombres
;================================================================================================

HPDF_Page_SetRGBFill(page, 0, 0, 0)
HPDF_Page_SetFontAndSize(page, font, 12)
HPDF_Page_BeginText(page)
HPDF_Page_TextOut(page, 140+(60-HPDF_Page_TextWidth(page, caseA1))/2, 470, caseA1)
HPDF_Page_TextOut(page, 200+(60-HPDF_Page_TextWidth(page, caseA2))/2, 470, caseA2)
HPDF_Page_TextOut(page, 140+(60-HPDF_Page_TextWidth(page, caseA3))/2, 440, caseA3)
HPDF_Page_TextOut(page, 200+(60-HPDF_Page_TextWidth(page, caseA4))/2, 440, caseA4)

HPDF_Page_TextOut(page, 560+(60-HPDF_Page_TextWidth(page, caseB1))/2, 470, caseB1)
HPDF_Page_TextOut(page, 620+(60-HPDF_Page_TextWidth(page, caseB2))/2, 470, caseB2)
HPDF_Page_TextOut(page, 560+(60-HPDF_Page_TextWidth(page, caseB3))/2, 440, caseB3)
HPDF_Page_TextOut(page, 620+(60-HPDF_Page_TextWidth(page, caseB4))/2, 440, caseB4)

HPDF_Page_TextOut(page, 140+(60-HPDF_Page_TextWidth(page, caseC1))/2, 170, caseC1)
HPDF_Page_TextOut(page, 200+(60-HPDF_Page_TextWidth(page, caseC2))/2, 170, caseC2)
HPDF_Page_TextOut(page, 140+(60-HPDF_Page_TextWidth(page, caseC3))/2, 140, caseC3)
HPDF_Page_TextOut(page, 200+(60-HPDF_Page_TextWidth(page, caseC4))/2, 140, caseC4)

HPDF_Page_TextOut(page, 560+(60-HPDF_Page_TextWidth(page, caseD1))/2, 170, caseD1)
HPDF_Page_TextOut(page, 620+(60-HPDF_Page_TextWidth(page, caseD2))/2, 170, caseD2)
HPDF_Page_TextOut(page, 560+(60-HPDF_Page_TextWidth(page, caseD3))/2, 140, caseD3)
HPDF_Page_TextOut(page, 620+(60-HPDF_Page_TextWidth(page, caseD4))/2, 140, caseD4)

HPDF_Page_SetFontAndSize(page, font, 10)
HPDF_Page_SetRGBFill(page, 1, 0, 0)
HPDF_Page_TextOut(page, 140+(60-HPDF_Page_TextWidth(page, caseA7))/2, 370, caseA7)
HPDF_Page_TextOut(page, 200+(60-HPDF_Page_TextWidth(page, caseA8))/2, 370, caseA8)
HPDF_Page_TextOut(page, 300+(60-HPDF_Page_TextWidth(page, caseA5))/2, 470, caseA5)
HPDF_Page_TextOut(page, 300+(60-HPDF_Page_TextWidth(page, caseA6))/2, 440, caseA6)
HPDF_Page_TextOut(page, 300+(60-HPDF_Page_TextWidth(page, caseA9))/2, 370, caseA9)
HPDF_Page_TextOut(page, 40+(60-HPDF_Page_TextWidth(page, caseA10))/2, 370, caseA10)

HPDF_Page_TextOut(page, 560+(60-HPDF_Page_TextWidth(page, caseB7))/2, 370, caseB7)
HPDF_Page_TextOut(page, 620+(60-HPDF_Page_TextWidth(page, caseB8))/2, 370, caseB8)
HPDF_Page_TextOut(page, 720+(60-HPDF_Page_TextWidth(page, caseB5))/2, 470, caseB5)
HPDF_Page_TextOut(page, 720+(60-HPDF_Page_TextWidth(page, caseB6))/2, 440, caseB6)
HPDF_Page_TextOut(page, 720+(60-HPDF_Page_TextWidth(page, caseB9))/2, 370, caseB9)
HPDF_Page_TextOut(page, 460+(60-HPDF_Page_TextWidth(page, caseB10))/2, 370, caseB10)

HPDF_Page_TextOut(page, 140+(60-HPDF_Page_TextWidth(page, caseC7))/2, 70, caseC7)
HPDF_Page_TextOut(page, 200+(60-HPDF_Page_TextWidth(page, caseC8))/2, 70, caseC8)
HPDF_Page_TextOut(page, 300+(60-HPDF_Page_TextWidth(page, caseC5))/2, 170, caseC5)
HPDF_Page_TextOut(page, 300+(60-HPDF_Page_TextWidth(page, caseC6))/2, 140, caseC6)
HPDF_Page_TextOut(page, 300+(60-HPDF_Page_TextWidth(page, caseC9))/2, 70, caseC9)
HPDF_Page_TextOut(page, 40+(60-HPDF_Page_TextWidth(page, caseC10))/2, 70, caseC10)

HPDF_Page_TextOut(page, 560+(60-HPDF_Page_TextWidth(page, caseC7))/2, 70, caseC7)
HPDF_Page_TextOut(page, 620+(60-HPDF_Page_TextWidth(page, caseC8))/2, 70, caseC8)
HPDF_Page_TextOut(page, 720+(60-HPDF_Page_TextWidth(page, caseC5))/2, 170, caseC5)
HPDF_Page_TextOut(page, 720+(60-HPDF_Page_TextWidth(page, caseC6))/2, 140, caseC6)
HPDF_Page_TextOut(page, 720+(60-HPDF_Page_TextWidth(page, caseC9))/2, 70, caseC9)
HPDF_Page_TextOut(page, 460+(60-HPDF_Page_TextWidth(page, caseC10))/2, 70, caseC10)
HPDF_Page_SetRGBFill(page, 0, 0, 0)
HPDF_Page_EndText(page)

;================================================================================================
; Ajout de la consigne
;================================================================================================
if (Consigne <> "")
	{
	 HPDF_Page_SetFontAndSize(page, font, 10)
	 HPDF_Page_BeginText(page)
	 HPDF_Page_TextOut(page, 40, 530, "Consigne : " Consigne)
	 HPDF_Page_TextOut(page, 40, 230, "Consigne : " Consigne)
	 HPDF_Page_TextOut(page, 460, 530, "Consigne : " Consigne)
	 HPDF_Page_TextOut(page, 460, 230, "Consigne : " Consigne)
	 HPDF_Page_EndText(page)
	}

if (Competence <> "")
	{
	HPDF_Page_SetFontAndSize(page, font, 8)
	 HPDF_Page_BeginText(page)
	 HPDF_Page_TextOut(page, 40, 560, "Comptence : " Competence)
	 HPDF_Page_TextOut(page, 40, 260, "Comptence : " Competence)
	 HPDF_Page_TextOut(page, 460, 560, "Comptence : " Competence)
	 HPDF_Page_TextOut(page, 460, 260, "Comptence : " Competence)
	 HPDF_Page_EndText(page)
	}
	

;================================================================================================
;Enregistre le PDF cr
;================================================================================================
NomFichierCorrection = %PDFDir%\%NomFichier%Correction.pdf
IfExist, %NomFichierCorrection%
	{
	MsgBox, 4, , Une fiche avec ce nom existe dj. Voulez-vous le remplacer ?
	IfMsgBox, No
		{
		NomFichierCorrection= %PDFDir%\%NomFichier%01.pdf
		HPDF_SaveToFile(hDoc, NomFichierCorrection)
		}
	Else
		{
		HPDF_SaveToFile(hDoc, NomFichierCorrection)
		}
	}
Else
	{
	HPDF_SaveToFile(hDoc, NomFichierCorrection)
	}

; Informe l'utilisateur de la fin de cration du PDF
LogStatus("Cration de la fiche-correction termine.")

; Rend cliquable le bouton "Lire le PDF"
GuiControl, Enable, ReadPDFCorrection
Return
}


;================================================================================================
;================================================================================================
;Lecture du PDF de correction en ouvrant SumatraPDF
;================================================================================================
;================================================================================================
ReadPDFCorrection:
{
RunWait, "%PDFLecteur%" "%NomFichierCorrection%"
Return
}

;================================================================================================
;================================================================================================
; Aide - Ouvre un PDF contenant l'aide
;================================================================================================
;================================================================================================
Aide:
{
FichierAide := A_ScriptDir . "\aide.pdf"
RunWait, "%PDFLecteur%" "%FichierAide%"
Return
}

;================================================================================================
;================================================================================================
; Gestion du bouton Quitter
;================================================================================================
;================================================================================================
GuiClose:
	;unload dll
	HPDF_UnloadDLL(hDll)
	
	ExitApp
Return






LogStatus(LogMessage)
{
	global LogMsg, LogDisplay
	LogMsg .= LogMessage . "|"
	SB_SetText(LogMessage)
	GuiControl, 3: , LogDisplay, %LogMessage%||
Return
}



; ================================================================================
;					 Gestion des Fentres supplmentaires
; ================================================================================

LogWindow:
{
	Gui, 3:+owner1 -SysMenu
	Gui, 3:Add, ListBox, x5 y5 w490 h300 ReadOnly vLogDisplay, %LogMsg%
	Gui, 3:Add, Button, x245 y310 w80 h25 gLogClose, Quitter
	Gui, 3:Show, Center h340 w500, Fentre de Log
Return
}

LogClose:
	Gui, 1:-Disabled
	Gui, Destroy
Return
